cda.reference = {}

----------------------------------------------------------------
-- Functions in cda.observation accept a <reference> element. --
----------------------------------------------------------------

function cda.reference.setExternalObservation(R, Id, ClassCode)
   R:setInner('<externalObservation><id root="#"/></externalObservation>')
   if ClassCode then
      R.externalObservation:setAttr('classCode', ClassCode)
   end
   R.externalObservation.id.root = Id
   return R.externalObservation
end

function cda.reference.setSeperatableInd(R, Flag)
   local SI = imp.getOrCreateElement(R, 'seperatableInd')
   SI:setAttr('value', tostring(Flag))
   return SI
end

function cda.reference.addExternalDocument(R)
   return R:append(xml.ELEMENT, 'externalDocument')
end
